Name:		swfdec
Version:	0.3.6
Release:	gst.2
Summary:	Flash animations redering library

Group:		Libraries/Multimedia
License:	LGPL
URL:		http://swfdec.sourceforge.net/
Vendor:         GStreamer Backpackers Team <package@gstreamer.net>
Source:		http://swfdec.sourceforge.net/download/%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-root
BuildRequires:  mozilla-devel
BuildRequires:	gtk2-devel => 2.2.0
Requires:	gtk2 => 2.2.0
Prereq:		/sbin/ldconfig

%description
Libswfdec is a library for rendering Flash animations. Currently it handles mostFlash 3 animations and some Flash 4. No interactivity is supported yet.

%package devel
Summary:	swfdec development files and static libraries.
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
swfdec-devel contains the files needed to build packages that depend on swfdec.

%package mozilla
Summary: Mozilla plugin for Flash rendering
Group:   Applications/Internet
Requires:  %{name} = %{version}-%{release}
Requires:  mozilla

%description mozilla
Mozilla plugin for rendering of Flash animations based on swfdec library

%prep
%setup -q 

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%makeinstall
# Clean out files that should not be part of the rpm.
# This is the recommended way of dealing with it for RH8
rm -f $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/2.2.0/loaders/swf_loader.la
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/gtk-2.0/gdk-pixbuf.loaders
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
mkdir -p %{_sysconfdir}/gtk-2.0
gdk-pixbuf-query-loaders > %{_sysconfdir}/gtk-2.0/gdk-pixbuf.loaders

%postun
/sbin/ldconfig
gdk-pixbuf-query-loaders > %{_sysconfdir}/gtk-2.0/gdk-pixbuf.loaders


%files
%defattr(-,root,root)
%doc AUTHORS COPYING NEWS README TODO 
%{_bindir}/swf_play
%{_libdir}/libswfdec.so.*
%{_libdir}/gtk-2.0/2.2.0/loaders/swf_loader.so

%files devel
%defattr(-,root,root)
%{_libdir}/libswfdec.a
%{_libdir}/libswfdec.so
%{_libdir}/pkgconfig/swfdec.pc
%{_includedir}/swfdec/swf.h
%{_includedir}/swfdec/swfdec.h
%{_libdir}/gtk-2.0/2.2.0/loaders/swf_loader.a

%files mozilla
%defattr(-,root,root)
%{_libdir}/mozilla/plugins/libmozswfdec.so*
%{_libdir}/mozilla/plugins/libmozswfdec.a

%changelog
* Wed Feb 05 2003 Christian F.K. Schaller <Uraeus@linuxrising.org>
- Update spec to handle pixbuf loader
* Sat Oct 26 2002 Christian F.K. Schaller <Uraeus@linuxrising.org>
- First attempt at spec
